/***************************************************************************
                          sqlguidoc.cpp  -  description
                             -------------------
    begin                : Sat Apr 14 18:28:06 CEST 2001
    copyright            : (C) 2001 by mb
    email                : marcus@beranek.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qdir.h>
#include <qwidget.h>
#include <qstring.h>
#include <qapplication.h>

// include files for KDE
#include <kapplication.h>
#include <klocale.h>
#include <kmessagebox.h>
#include <kio/job.h>

// application specific includes
//#include "sqlgui_part.h"
//#include "sqlguiview.h"
#include <qcursor.h>
#include <qapplication.h>

#include <iostream>
#include <iomanip>

#include "sqlguidoc.h"
using namespace std;

SqlGuiDoc::SqlGuiDoc(QWidget *parent, const char *name) : QObject(parent, name){

  if(!name){setName("doc");}
  const QString catalogue = "sqlguipart";
  kl = new KLocale( catalogue, 0 );
  kl->setActiveCatalogue( catalogue );
  kl->setMainCatalogue( "sqlguipart" );

  DB = NULL;
  RESULT = NULL;
  RESULT_Start = NULL;

  doc_host.setLatin1("");
  doc_uname.setLatin1("");
  doc_pass.setLatin1("");
  doc_base.setLatin1("");
  doc_port = 0;

  connectionEnabled=false;

  QUERY     = new QString;
  STATUS    = new QString;

  // gibt es in mysql eine String-Begrenzung fr DB-Name etc. auf 256 Zeichen?
  // falls nicht, mu hier noch nachgebessert werden...
  lastDB    = new QString("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
  lastTable = new QString("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
  primKey   = new QString("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");

  lastDB->setLatin1("");
  lastTable->setLatin1("");
  primKey->setLatin1("");

  connect( this, SIGNAL( DbErased() ), this, SLOT( slotReConnect() ) );
  connect( this, SIGNAL( TableErased() ), this, SLOT( slotReConnect() ) );
  connect( this, SIGNAL( NewDbCreated() ), this, SLOT( slotReConnect() ) );
  connect( this, SIGNAL( NewTableCreated() ), this, SLOT( slotReConnect() ) );

  lastCols = NULL;
  basePosition = NULL;
  tablePosition = NULL;
  rowPosition = NULL;
  fieldPosition = NULL;
  view = NULL;

}

SqlGuiDoc::~SqlGuiDoc(){

}

/////////////////////////////////////////////////////////////////
//* Pure virtual member-functions:
/////////////////////////////////////////////////////////////////

bool SqlGuiDoc::openDocument(const QString& url, const QString& uname, const QString& pwd, const QString& base ){}

void SqlGuiDoc::slotDoQuery(QString * Base, QString* Anfrage){}
void SqlGuiDoc::slotDbCreate( QString* ){}
void SqlGuiDoc::slotDbDelete( QString* db ){}
void SqlGuiDoc::slotTableDelete(QString* db, QString* tb){}
void SqlGuiDoc::slotTableCheck(QString* db, QString* tb){}
void SqlGuiDoc::slotTableOptimize(QString* db, QString* tb){}
void SqlGuiDoc::slotTableRepair(QString* db, QString* tb){}
void SqlGuiDoc::slotServerStatus(){}
void SqlGuiDoc::slotCountRows( QString* _db, QString* _tb){}

QString SqlGuiDoc::getProtocol(){}
int SqlGuiDoc::getDBType(){}

/////////////////////////////////////////////////////////////////
//* Non virtual member-functions:
/////////////////////////////////////////////////////////////////

void SqlGuiDoc::clearResult(){
  if( RESULT_Start ){ RESULT_Start = clearrw( &RESULT_Start ); }
  RESULT=NULL;
}

row_t * SqlGuiDoc::clearrw( row_t ** rw ){
  //  // std::cout << "Request for removing Row..." << endl;
  if( *rw ){
    if ((*rw)->next) { (*rw)->next = clearrw( &( (*rw)->next ) ); }
    if ((*rw)->feld){ (*rw)->feld = clearfd( &( (*rw)->feld) ); }
    delete (*rw);
    *rw = NULL;
  }
  return NULL;

}

field_t * SqlGuiDoc::clearfd( field_t ** fd ){
  //  // std::cout << "Request for removing Field..." << endl;
  if( *fd ){
    if ((*fd)->next) { (*fd)->next = clearfd( &( (*fd)->next ) ); }
    delete (*fd)->value;
    delete (*fd);
    *fd = NULL;
  }
  return NULL;

}

base_t* SqlGuiDoc::cleardb( base_t **  db){
  //  // std::cout << "Request for removing DB..." << endl;
  if( *db ){
    // std::cout << "Clearing memory for DB " << (*db)->name << endl;
    if ((*db)->next) { (*db)->next = cleardb( &( (*db)->next ) ); }
    if ((*db)->table_list){ (*db)->table_list = cleartb( &( (*db)->table_list) ); }
    //    // std::cout << (*db)->name << endl;
    delete (*db)->name;
    delete (*db);
    *db = NULL;
  }
  return NULL;
}


table_t* SqlGuiDoc::cleartb( table_t ** tb ){
  //  // std::cout << "Request for removing table..." << endl;
  if( *tb ){
    if ( (*tb)->next ) { (*tb)->next = cleartb( &((*tb)->next ) ); }
    if ( (*tb)->column_list){ (*tb)->column_list = clearsp( &( (*tb)->column_list) ); }
    //    // std::cout << (*tb)->name << endl;
    delete (*tb)->name;
    //    delete (*tb)->type_n;
    delete (*tb);
    *tb = NULL;
  }
  return NULL;
}


column_t * SqlGuiDoc::clearsp( column_t ** sp){
  //  // std::cout << "Request for removing Column..." << endl;
  if( *sp ){
    if ( (*sp)->next) { (*sp)->next = clearsp( &( (*sp)->next ) ); }
    //    // std::cout << (*sp)->name << endl;
    delete (*sp)->name;
    delete (*sp)->type;
    delete (*sp)->extra_flags;
    delete (*sp);
    *sp = NULL;
  }
  return NULL;
}

void SqlGuiDoc::slotClearMemory(){
  // std::cout << "Got request for clearing memory..." << endl;
  //  this->clearResult();
  clearResult();
  // std::cout << "Clearing done." << endl;
}

QString SqlGuiDoc::getDbFromSQL(QString * sql){
  return QString::QString("");
}

QString SqlGuiDoc::getTableFromSQL(QString * sql){
  uint i=0;
  uint l=0;
  bool gotToken=false;
  bool gotTable=false;
  QString * token = new QString;
  QString * table = new QString;
  QString * data  = new QString;

  if(sql) l=sql->length();

  token->setLatin1("");
  table->setLatin1("");
  data->setLatin1("");

  // Wir mssen als erstes den String in seine Schlsselworte - getrennt durch Leerzeichen - aufspalten:
  while(i<l){
    char a = sql->at(i).latin1();
    if( a != ' ' ){
      gotToken=false;
      token->append(a);
    } else {
      gotToken=true;
    }
    // Haben wir ein Schlsselwort, dann mssen wir schauen, ob wir es kennen:
    if(gotToken){
      // Wir vergleichen nur GROSSBUCHSTABEN:
      token = &(token->upper());

      if( (token->compare("FROM")==0) || (token->compare("INTO")==0) || (token->compare("UPDATE")==0) || (token->compare("TABLE")==0) ){
	//
	// typ. Flle:
	// SELECT * FROM table WHERE xyz LIKE 'bla'
	// SELECT * FROM database.table WHERE xyz LIKE 'bla'
	//
	// INSERT INTO table (xyz) values (bla-bla)
	// INSERT INTO database.table (xyz) values (bla-bla)
	//
	// UPDATE table SET xyz='bla'
	// UPDATE database.table SET xyz='bla'
	//
	bool go=true;
	QString * key = new QString;
	char y;
	bool gotDot=false;
	// Nchstes Token suchen:
	while(go){
	  i++;
	  y = sql->at(i).latin1();
	  // Wie wandeln nicht in Grobuchstaben um, denn wir wollen ja den Tabellen-Namen (der ist case-sensitiv).
	  if( y != ' ' ){
	    go=true;
	    key->append(y);
	    if( y == '.' ) gotDot=true;
	  }
	  else{
	    go=false;
	  }
	}
	// So, jetzt haben wir "Tabelle" oder "Datenbank.Tabelle":
	gotTable=true;
	if(gotDot){
	  // Aufspalten:
	  uint m = key->length();
	  uint n=0;
	  bool before=true;
	  while(n<m){
	    char b = key->at(n).latin1();
	    if( b != '.' ){
	      if(before) data->append(b);
	      else table->append(b);
	    }
	  }
	} else {
	  // Wir haben bereits die Tabelle:
	  table->setLatin1( key->latin1() );
	}
      }
      // Token zurcksetzen und Platz fr das nchste schaffen:
      token->setLatin1("");
    }
    // Weiter im Text:
    i++;
    if(gotTable)break;
  }
  return *table;
}

void SqlGuiDoc::setView(SqlGuiView* v){
  view = v;
}

void SqlGuiDoc::setURL(const KURL &url){
  doc_url=url;
}

const KURL& SqlGuiDoc::URL() const{
  return doc_url;
}

base_t* SqlGuiDoc::getActualBase(){
  return basePosition;
}

table_t* SqlGuiDoc::getActualTable(){
  return tablePosition;
}

column_t* SqlGuiDoc::getActualColumn(){
  return columnPosition;
}

row_t* SqlGuiDoc::getActualRow(){
  return rowPosition;
}

field_t* SqlGuiDoc::getActualField(){
  return fieldPosition;
}


QString SqlGuiDoc::getActualBaseName(){
  QString* n = new QString(basePosition->name);
  return *n;
}

QString SqlGuiDoc::getActualTableName(){
  QString* n = new QString(tablePosition->name);
  return *n;
}

QString SqlGuiDoc::getActualTableType(){
  QString* n = new QString( QChar::QChar(tablePosition->type) );
  return *n;
}

QString SqlGuiDoc::getActualColumnName(){
  QString* n = new QString(columnPosition->name);
  return *n;
}


bool SqlGuiDoc::gotoNextBase(){
  bool ok = false;
  if(basePosition->next){
    basePosition = basePosition->next;
    tablePosition = basePosition->table_list;
    columnPosition = tablePosition->column_list;
    ok = true;
  }
  return ok;
}

bool SqlGuiDoc::gotoNextTable(){
  bool ok = false;
  if(tablePosition->next){
    tablePosition = tablePosition->next;
    columnPosition = tablePosition->column_list;		
    ok = true;
  }
  return ok;
}

bool SqlGuiDoc::gotoNextColumn(){
  bool ok = false;
  if(columnPosition->next){
    columnPosition = columnPosition->next;
    ok = true;
  }
  return ok;
}

bool SqlGuiDoc::gotoNextRow(){
  bool ok = false;
  if(rowPosition->next){
    rowPosition = rowPosition->next;
    ok = true;
  }
  return ok;
}

bool SqlGuiDoc::gotoNextField(){
  bool ok = false;
  if(fieldPosition->next){
    fieldPosition = fieldPosition->next;
    ok = true;
  }
  return ok;
}


QString* SqlGuiDoc::resultDB(){
  return lastDB;
}

QString* SqlGuiDoc::resultTable(){
  return lastTable;
}

column_t* SqlGuiDoc::resultCols(){
  return lastCols;
}


bool SqlGuiDoc::newDocument(){
  doc_url.setFileName(kl->translate( i18n("Not connected")));
  return true;
}

void SqlGuiDoc::slotReConnect(){
  // std::cout << "Reconnecting... " << endl;
  QString *h = new QString( doc_host );
  QString *u = new QString( doc_uname );
  QString *p = new QString( doc_pass );
  QString *b = new QString( doc_base );
  openDocument( *h, *u, *p, *b );
}

void SqlGuiDoc::slotDoLogin( QString url, QString uname, QString pwd, QString base){
  openDocument(url,uname,pwd,base);
}

QString * SqlGuiDoc::getPrimaryKey(){
  return primKey;
}

QString SqlGuiDoc::getHost(){
  return doc_host;
}

QString SqlGuiDoc::getBase(){
  return doc_base;
}

QString SqlGuiDoc::getUser(){
  return doc_uname;
}

QString SqlGuiDoc::getPass(){
  return doc_pass;
}

bool SqlGuiDoc::isConnected(){
  return connectionEnabled;
}

QString * SqlGuiDoc::getLastTable(){
  return lastTable;
}

unsigned short int SqlGuiDoc::getPort(){
  return doc_port;
}



base_t * SqlGuiDoc::getDBs(){
  return DB;
}

row_t * SqlGuiDoc::getFirstRes(){
  return RESULT_Start;
}

row_t * SqlGuiDoc::getNextRes(){
  row_t* help=RESULT;
  RESULT=RESULT->next;
  if(!RESULT){
    RESULT=RESULT_Start;
  }
  return help;
}

//#include "sqlguidoc.moc.cpp"
